//========================================================================================
// BadPairPlotPanel.java
// ---------------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------------
// $Id: //CBT-depot/CompBioTools++/includes/Mer.hh#1 $
//----------------------------------------------------------------------------------------
//
//========================================================================================
//.......1.........2.........3.........4.........5.........6.........7.........8.........9
//

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

//import CBT;

//-----------------------------------------------------------------------------
// * BadPairPlotPanel
//-----------------------------------------------------------------------------
//
public class BadPairPlotPanel extends JPanel 
	 implements ListSelectionListener, 
					ComponentListener
{
	 private Dimension size; // indicates size taken up by graphics
	 TemplateDrawingArea mDrawingArea;
	 Ace    mA;
	 int    mScale;
	 int xaxis = 75;

	 private int cNum =0;
	 private int lastCNum =-1;
	 private int mNumBad = 0;

	 Color mReadColor = Color.green;
	 Color mTemplateColor = Color.blue;
	 
	 //--------------------------------
	 // * BadPairPlotPanel
	 //--------------------------------
	 //
	 public BadPairPlotPanel(final Ace a) {
		  mA = a;
		  setOpaque(true);
		  size = new Dimension(0,0);
		  
		  mScale = 25;
	 		
		  mDrawingArea = new TemplateDrawingArea();
		  mDrawingArea.setBackground(Color.white);
		  
		  //Put the drawing area in a scroll pane.
		  JScrollPane scroller = new JScrollPane(mDrawingArea);
		  scroller.setPreferredSize(new Dimension(300,xaxis+75));
		  
		  //Layout this demo.
		  setLayout(new BorderLayout());
		  //add(mKeyPanel, BorderLayout.SOUTH);
		  add(scroller, BorderLayout.CENTER);
		  		  
		  //Let the scroll pane know to update itself
		  //and its scrollbars.
		  mDrawingArea.revalidate();
		  setVisible(true);
	 }

	 //--------------------------------
	 // * ValueChanged
	 //--------------------------------
	 //
	 public void valueChanged(ListSelectionEvent e)
	 {
		  if (e.getValueIsAdjusting()) return;

		  JList theList = (JList)e.getSource();
		  if(theList.isSelectionEmpty()) return;
		  else{
			   cNum = theList.getSelectedIndex();

				int cSize = mA.GetContigSize(cNum);
				size.width = cSize/mScale;
				size.height = xaxis + 75;
				setPreferredSize(size);

			   mDrawingArea.revalidate();
				mDrawingArea.repaint();
		  }
	 }

	 // public Dimension getPreferredSize(){
	 //	  Dimension minsize = new Dimension(400,);
	 //	  return(minsize);
		  //return(size);
	 // }

	 public Dimension getMinimumSize(){
		  Dimension minsize = new Dimension(300,100);
		  return(minsize);
	 }

	 // Component listener 
	 public void componentResized(ComponentEvent e){
		  //int height = getHeight();
		  //xaxis = height - 75;
	 }

	 public void componentHidden(ComponentEvent e){};
	 public void componentMoved(ComponentEvent e){};
	 public void componentShown(ComponentEvent e){};


	 //-----------------------------------------------------------------------------
	 // * TemplateDrawingArea
	 //-----------------------------------------------------------------------------
	 //
	 class TemplateDrawingArea extends JPanel{

		  void DrawArrow(Graphics g,int arrowy,int x1,int x2){
				g.setColor(Color.red);

				// -->
				if (x1<x2){			
					 int awidth = (x2-x1+1);
					 g.fillRect(x1,arrowy,awidth,2);
					 g.drawLine(x2,arrowy,x2-3,arrowy-3);
					 g.drawLine(x2-3,arrowy+3+2,x2,arrowy+2);
				}else{
					 // <--
					 int awidth = (x1-x2+1);
					 g.fillRect(x2,arrowy,awidth,2);

					 g.drawLine(x2+1,arrowy,x2+4,arrowy-3);
					 g.drawLine(x2+1,arrowy+2,x2+4,arrowy+3+2);
				}
		  }

		  void ConnectArrows(Graphics g,int y, int r1x1,int r1x2,int r2x1,int r2x2){
				g.setColor(Color.magenta);
				int mid1 = (int)Math.abs((r1x2-r1x1)/2.0);
				int mid2 = (int)Math.abs((r2x2-r2x1)/2.0);

				if (r1x1 < r1x2) mid1+=r1x1;
				else mid1 += r1x2;

				if (r2x1 < r2x2) mid2+=r2x1;
				else mid2 += r2x2;
				
				g.drawLine(mid1,y,mid1,y-3);
				g.drawLine(mid1,y-3,mid2,y-3);
				g.drawLine(mid2,y,mid2,y-3);
		  }

		  protected void paintComponent(Graphics g) {
				super.paintComponent(g);
						 				
				int cSize = mA.GetContigSize(cNum);
				size.width = cSize/mScale;
				size.height = xaxis+30;
				//				size.height = getHeight();
				setPreferredSize(size);

				// If the selected contig has changed, recalculate
				// the coverage vector. 
				if (cNum != lastCNum){
					 mA.ComputeBadTemplateCoverage(cNum);
					 mA.ComputeCoverage(cNum);
					 mA.ComputeBadTemplateEndPoints(cNum);
					 lastCNum = cNum;

					 mNumBad = mA.GetNumBadTemplates();
				}

				int yspacing = 3;

				// Draw the X-axis and tick marks. 
				g.setColor(Color.black);
				for(int i = 0;i< cSize;i++){
					 if ((i%mScale) == 0){
						  g.fillRect(i/mScale,xaxis,2,2);
					 }
					 
					 if ((i%1000) == 0){
						  g.fillRect(i/mScale,xaxis-5,1,10);
					 }
					 
					 if ((i%5000) == 0){
						  String s = ""+i;
						  g.fillRect(i/mScale,xaxis-5,2,13);
						  g.drawString(s,i/mScale-20,xaxis+20);
					 }
				}
				
				// Draw the template coverage
				g.setColor(Color.blue);
				String label = "Bad Template Pairs ---";
				g.drawString(label,0,xaxis+20);
				String label2 = "Num bad template pairs:"+mNumBad; 
				g.drawString(label2,0,xaxis+30);				

				int arrowyspacing = 6;
				int pairNum = 1;
				
				for(int i = 0;i< mNumBad;i++){
					 int arrowy = xaxis - pairNum*arrowyspacing;
					 int x1 = mA.GetRStart1(i);
					 int x2 = mA.GetREnd1(i);
					 DrawArrow(g,arrowy,x1/mScale,x2/mScale);

					 int xa1 = mA.GetRStart2(i);
					 int xa2 = mA.GetREnd2(i);
					 DrawArrow(g,arrowy,xa1/mScale,xa2/mScale);

					 // Draw something to connect the arrows. 
					 ConnectArrows(g,arrowy,x1/mScale,x2/mScale,xa1/mScale,xa2/mScale);

					 pairNum++;
				}

				//for(int i = 0;i< cSize;i++){
				// if ((i%mScale) == 0){
				//	  int tc = mA.GetBadTemplateCoverage(i);
						  
				//	  if (tc == 0){
				//			g.setColor(Color.red);
				//			g.fillRect(i/mScale,xaxis-(tc*yspacing),1,2);
				//			g.setColor(Color.blue);
				//	  }else{
				//			g.fillRect(i/mScale,xaxis-(tc*yspacing),1,2);
				//	  }
				// }
				//	}		
				
				// Draw the coverage.
				//g.setColor(Color.green);
				//label = "Read --";
				//g.drawString(label,0,xaxis+30);
				//for(int i = 0;i< cSize;i++){
				//	 if ((i%mScale) == 0){
				//		  int cvg = mA.GetCoverage(i);
						  
				//	  if (cvg == 0){
				//			g.setColor(Color.red);
				//			g.fillRect(i/mScale,xaxis-(cvg*yspacing),1,2);
				//			g.setColor(Color.green);
				//	  }else{
				//			g.fillRect(i/mScale,xaxis-(cvg*yspacing),1,2);
				//	  }
				// }
				//}								
		  }
	 }	 
}

	

// ToDo:
//
// * Have some way to measure the size of features
//     - Two vertical bars that can be slid around?
//     - Just report size of read regions?  
//     - More fine scale (tic marks). 
//
// * Add scale chooser (menu? +/- button? Slider?)
//
// * Integrate in template pair display. 
//
// ========================================
//
// * Color template coverage by size of template?
// * Fix so that scroll bars update more automatically. 
// * Improve performance (esp. Ace reading). 
// 
// * Plot WGS/BAC separately.   
// * Plot unhappy templates (pairs where mate isn't where/orientation expect). 
//    - length = template length.
//    - below, sort of a negative scale.    
//    - bac/wgs separate.   
// * Mouse indicate depth.  
// * Plot Quality

// * Option for template depth or fly-over template depth.  


// * Plot high quality descrepencies.  (lower priority). 
 
// ============================================


// Getting test data ideas:
// 
//   Restrict to projects finished in 2001.  
// * Look at lowest numbered consed assembly.  
//   - Ideally prefilter to remove trimmed ones
//   - Get NCBI record see if/how trimmed.  
// Maybe 1000 projects not trimmed? 
//


// Template cov
// -  0
// ?  1
// 
// Read cov
// - 0
// ? significantly below/above expectation


// Unhappy templates
// ? 1
// - > 1 


// 

// ===================
// * Option to display BAC library separately or all together.  Partition by first 4 char. 


// I think I am seeing two kinds of false joins:
// 
// For one the template coverage crashes while the read coverage 
// goes up.  This suggests a repeat is bridging two unrelated 
// contigs. 
// 
// It is not obvious how or where to split this sort of misjoin. 

// For the other, the template coverage crashes just before the
// read coverage crashes.   Basically, there is a single read, 
// or very small number of reads, connecting two unrelated 
// contigs. 
// 
// Splitting this should be easy, simply remove the offending
// read in the intersection and 


// ** Summary statistics
//    - How many WGS only BACs, How many BACs with apparent template crashes, etc. 



		  // Create a key
		  //Vector Labels = new Vector();
		  //Vector Colors = new Vector();
		  //Labels.add(new String("Template --"));
		  //Labels.add(new String("Read --"));
		  //Colors.add(Color.green);
		  //Colors.add(Color.blue);

		  //mKeyPanel = new KeyPanel(Colors,Labels);

