//========================================================================================
// KeyPanel.java
// ---------------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------------
// $Id: //CBT-depot/CompBioTools++/includes/Mer.hh#1 $
//----------------------------------------------------------------------------------------
//
//========================================================================================
//.......1.........2.........3.........4.........5.........6.........7.........8.........9
//

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;


//-----------------------------------------------------------------------------
// * KeyPanel
//-----------------------------------------------------------------------------
//
public class KeyPanel extends JPanel {

	 Vector mColors;
	 Vector mLabels;
	 Vector mLabelWidths;
	 int    mFontHeight;

	 KeyPanel(Vector Colors,Vector Labels){
		  mColors = Colors;
		  mLabels = Labels;
		  
		  // Precompute the size of the labels since the FontMetrics classes are 
		  // inefficient. 
		  Graphics g = getGraphics();
		  Font currentFont = g.getFont();
		  FontMetrics currentMetrics = getFontMetrics(currentFont);
		  mFontHeight = currentMetrics.getHeight();
		  for(int i = 0;i< mLabels.size();i++){
				String l = (String) mLabels.get(i);
				Integer swidth = new Integer(currentMetrics.stringWidth(l));
				mLabelWidths.add(swidth);
		  }
	 }

	 protected void paintComponent(Graphics g) {
		  super.paintComponent(g);
		  
		  int y = 5;
		  for(int i = 0;i< mLabels.size();i++){			 
				Color c = (Color) mColors.get(i);
				String l = (String) mLabels.get(i);

				Integer wInt = (Integer)mLabelWidths.get(i);
				int w = wInt.intValue();
				g.setColor(c);
				g.drawString(l,mFontHeight+5,y);
				y = y + w;
		  }
	 }	 
}
 
	
